diff -ur asterisk-trunk/apps/app_queue.c asterisk-trunk.unanswered_queue/apps/app_queue.c
--- asterisk-trunk/apps/app_queue.c	2008-10-14 13:08:29.000000000 -0200
+++ asterisk-trunk.unanswered_queue/apps/app_queue.c	2008-10-14 13:52:08.000000000 -0200
@@ -3372,8 +3372,12 @@
 			/* User exited by pressing a digit */
 			res = digit;
 		}
-		if (res == -1)
+		if (res == -1) {
+			/* Post this CDR, and mark call as NOANSWER */
+			ast_set_flag(qe->chan->cdr, AST_CDR_FLAG_DONT_TOUCH);
+			ast_cdr_noanswer(qe->chan->cdr);
 			ast_debug(1, "%s: Nobody answered.\n", qe->chan->name);
+		}
 	} else { /* peer is valid */
 		/* Ah ha!  Someone answered within the desired timeframe.  Of course after this
 		   we will always return with -1 so that it is hung up properly after the
diff -ur asterisk-trunk/main/cdr.c asterisk-trunk.unanswered_queue/main/cdr.c
--- asterisk-trunk/main/cdr.c	2008-10-14 13:08:31.000000000 -0200
+++ asterisk-trunk.unanswered_queue/main/cdr.c	2008-10-14 13:34:36.000000000 -0200
@@ -1005,7 +1005,7 @@
 	struct ast_cdr_beitem *i;
 
 	for ( ; cdr ; cdr = cdr->next) {
-		if (!unanswered && cdr->disposition < AST_CDR_ANSWERED && (ast_strlen_zero(cdr->channel) || ast_strlen_zero(cdr->dstchannel))) {
+		if (!unanswered && !ast_test_flag(cdr, AST_CDR_FLAG_DONT_TOUCH) && cdr->disposition < AST_CDR_ANSWERED && (ast_strlen_zero(cdr->channel) || ast_strlen_zero(cdr->dstchannel))) {
 			/* For people, who don't want to see unanswered single-channel events */
 			ast_set_flag(cdr, AST_CDR_FLAG_POST_DISABLED);
 			continue;
